!= Module Radiation
!
! Authors::   SUGIYAMA Ko-ichiro
! Version::   $Id: radiation.f90,v 1.2 2011-02-23 17:08:00 yamasita Exp $
! Tag Name::  $Name: arare4-20110603 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview
!
!ǥͲ׻뤿Υѥå⥸塼
!Ūˤϰʲι׻뤿δؿǼ.  
!  * 
!
!ͤХ󥹤ץΥХ. 
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!
!== Future Plans
!
!

module Radiation
  !
  !ǥͲ׻뤿Υѥå⥸塼
  !Ūˤϰʲι׻뤿δؿǼ.  
  !  * 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify

  use GridSet,  only: DimXMin,     & !x β
    &                 DimXMax,     & !x ξ
    &                 DimZMin,     & !z β
    &                 DimZMax,     & !z ξ
    &                 RegXMin,     & !x β
    &                 RegXMax,     & !x ξ
    &                 RegZMin,     & !z β
    &                 RegZMax,     & !z ξ
    &                 s_Z,         & !Z ɸ(顼ʻ)
    &                 DelZ           !ʻҴֳ
  use TimeSet,  only: DayTime        ! 1 Ĺ [s]
  use basicset, only: xz_ExnerBasicZ, & !ʡؿδܾ
    &                 xz_PressBasicZ, & !Ϥδܾ
    &                 xz_PotTempBasicZ, & !̤δܾ
    &                 PressSfc,       & !ɽ̰
    &                 CpDry,          & !갵Ǯ
    &                 CvDry,          & !Ǯ
    &                 GasRDry,        & !
    &                 Grav              !ϲ®
  use StorePotTemp,  only: StorePotTempRad, StorePotTempDamp
  
  !ۤηػ
  implicit none

  !private °
  private

  !ؿ public ˤ. 
  public Radiation_init
  public xz_RadHeatConst
  public xz_RadHeatBalance
  public xz_NewtonCool

  !ѿ
  real(8)              :: RadHeatRate  = 0.0d0 !ͲǮΨ [K/day]
  real(8), allocatable :: xz_RadHeight(:,:)    !ͲǮ¸ߤΰ
  real(8)              :: RadCoolRate  = 0.0d0 !ͲǮΨ [K/day]
  real(8), allocatable :: xz_RadHeight2(:,:)    !ͲǮ¸ߤΰ
!  real(8)              :: HeatWork      !ˤ
!                                        !ñ̻֤βǮ()
  integer              :: IntHeightUp   !Ǯ¤αľɸб
                                        !
  integer              :: IntHeightUp2   !Ѱ¤αľɸб
                                         !
  real(8)                  :: RadHeightUp   !ͶͿľΰξ
  real(8)                  :: RadHeightDown !ͶͿľΰβ
  real(8)                  :: RadHeightUp2   !ͶͿľΰξ
  real(8)                  :: RadHeightDown2 !ͶͿľΰβ
  
  !save °
!  save RadHeatRate, xz_RadHeight
!  save RadHeatRate, xz_RadHeight, RadCoolRate, xz_RadHeight2, HeatWork
  save RadHeatRate, xz_RadHeight, RadCoolRate, xz_RadHeight2
  save IntHeightUp, IntHeightUp2, RadHeightUp, RadHeightDown, RadHeightUp2, RadHeightDown2

contains

!!!------------------------------------------------------------------------!!!
  subroutine Radiation_init(cfgfile)
    !
    !NAMELIST Ͷ
    !

    !ۤηػ
    implicit none

    !ѿ
    character(*), intent(in) :: cfgfile
    integer                  :: k             !롼ѿ


    ! NAMELIST 
    NAMELIST /radiation/ RadHeatRate, RadHeightUp, RadHeightDown, RadCoolRate, RadHeightUp2, RadHeightDown2

    open (10, FILE=cfgfile)
    read(10, NML=radiation)
    close(10)

    allocate( xz_RadHeight(DimXMin:DimXMax, DimZMin:DimZMax) )
    allocate( xz_RadHeight2(DimXMin:DimXMax, DimZMin:DimZMax) )

    ! IntHeightUp 
    do k = DimZMin, DimZMax
      if ( (RadHeightUp - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp) ) then
        IntHeightUp = k
      else if ( (RadHeightUp2 - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp2) ) then
        IntHeightUp2 = k
      end if
    end do

    write(*,*) s_Z(IntHeightUp)
    write(*,*) s_Z(IntHeightUp2)

!    ! PressHeightUp λ
!    PressHeightUp =  xz_PressBasicZ(1,IntHeightUp) +  &
!     & ( xz_PressBasicZ(1,IntHeightUp + 1) - xz_PressBasicZ(1,IntHeightUp) ) &
!     & * ( RadHeightUp - s_Z(IntHeightUp) ) / DelZ

!    ! HeatWork λ
!    HeatWork = CpDry * RadHeatRate * ( PressSfc - PressHeightUp ) / Grav

    ! Ͷ¸ߤΰ
    ! RadHeightDown < s_Z < RadHeightUp ϰϤǤͤ 1 Ȥʤ
    ! Ѱդ.
    !
    xz_RadHeight = 1.0d0    
    xz_RadHeight2 = 1.0d0    

    do k = DimZMin, DimZMax
      if ( s_Z(k) <= RadHeightDown  ) then
        xz_RadHeight(:,k) = 0.0d0 
      elseif( s_Z(k) >= RadHeightUp ) then
        xz_RadHeight(:,k) = 0.0d0 
      end if
    end do

    do k = DimZMin, DimZMax
      if ( s_Z(k) <= RadHeightDown2  ) then
        xz_RadHeight2(:,k) = 0.0d0 
      elseif( s_Z(k) >= RadHeightUp2 ) then
        xz_RadHeight2(:,k) = 0.0d0 
      end if
    end do

    call MessageNotify( "M", &
      & "Radiation", "RadHeatRate = %f", d=(/RadHeatRate/))
    call MessageNotify( "M", &
      & "Radiation", "RadHeightUp = %f", d=(/RadHeightUP/))
    call MessageNotify( "M", &
      & "Radiation", "RadHeightDown= %f", d=(/RadHeightDown/))
    call MessageNotify( "M", &
      & "Radiation", "RadCoolRate = %f", d=(/RadCoolRate/))
    call MessageNotify( "M", &
      & "Radiation", "RadHeightUp2 = %f", d=(/RadHeightUP2/))
    call MessageNotify( "M", &
      & "Radiation", "RadHeightDown2 = %f", d=(/RadHeightDown2/))
!    call MessageNotify( "M", &
!      & "Radiation", "PressHeightUp = %f", d=(/PressHeightUp/))
    
  end subroutine Radiation_init


!!!------------------------------------------------------------------------!!!
  function xz_RadHeatConst(xz_Exner)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    ! ʡؿϴܾͿ. 
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !ʡؿξ
    real(8)               :: xz_RadHeatConst(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !Ͷ

!    xz_RadHeatConst = &
!      & xz_RadHeight * RadHeatRate  &
!      & / ( ( xz_ExnerBasicZ + xz_Exner ) * DayTime )

    xz_RadHeatConst = &
      & xz_RadHeight * RadHeatRate  &
      & / ( ( xz_ExnerBasicZ + xz_Exner ) * DayTime ) &
      & + xz_RadHeight2 * RadCoolRate  &
      & / ( ( xz_ExnerBasicZ + xz_Exner ) * DayTime )

    call StorePotTempRad( xz_RadHeatConst )
    
  end function xz_RadHeatConst


!!!------------------------------------------------------------------------!!!
  function xz_RadHeatBalance(xz_ExnerBasicZ, xz_PotTempBasicZ, xz_Exner, xz_PotTemp)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǶŪ˰ͤʲǮ, 
    ! RadHeight  RadHeight2 ޤǤδ֤ǶŪʰͤѤͿ. 
    ! ͶΤȤƲǮѤХ󥹤褦˻ͲǮΨ
    ! ӰΨѲ. 
    ! ѤοͿ, ǮοĴ᤹. 

    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)               :: xz_RadHeatBalance(DimXMin:DimXMax, DimZMin:DimZMax)
                                        !Ͷ
    real(8)               :: xz_DensSum(DimXMin:DimXMax, DimZMin:DimZMax) 
                                        !̩(ܾʬȾʬ)
!    real(8)               :: z_DensXmean(DimZMin:DimZMax)
!                                        !̩(ʿʿ)
!    real(8)               :: HeatRatio  !βǮΨȤβǮΨ
!    real(8)               :: CoolRatio  !ΨȤΨ
    real(8)               :: HeatSum    !Ǥñ̻βǮ
    real(8)               :: CoolSum    !Ǥñ̻
!    real(8)               :: WorkRad(DimXMin:DimXMax, DimZMin:DimZMax)    !Ǥñ̻
!    real(8)               :: WorkRad2   !Ǥñ̻
    integer               :: i
    integer               :: k

    ! ̩٤λ
    xz_DensSum = PressSfc &
      & * (xz_ExnerBasicZ + xz_Exner)**( CvDry /GasRDry ) &
      & / (GasRDry * (xz_PotTempBasicZ + xz_PotTemp ) )

!    ! ̩٤οʿʿѤλ
!    z_DensXmean = sum( xz_DensSum(RegXMin+1:RegXMax, :), 1) / real(RegXMax - RegXMin)

    HeatSum = 0.0d0
    CoolSum = 0.0d0

    !ǮΤ,  0 - 1000 m => ʻ 1 (RegZMin + 1)  IntHeightUp
    !ѤΤ,  1000 - 15000 m => ʻ IntHeightUp + 1  IntHeightUp2
    !*** ȴ *** 
    ! IntHeightUp 
    !do k = DimZMin, DimZMax
    !  if ( (RadHeightUp - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp) ) then
    !    IntHeightUp = k
    !  else if ( (RadHeightUp2 - DelZ <= s_Z(k)) .and. (s_Z(k) < RadHeightUp2) ) then
    !    IntHeightUp2 = k
    !  end if
    !end do
    !
    ! ü                           1000 
    !   |--*--|--*--|--*--|--*--|--*--|--*--|--*--|
    !      1                       5  
    !
    !  1000                                      Max
    !   |--*--|--*--|--*--|--*--|--*--|--*--|--*--|
    !      6                                   I

    ! Ǥ (Ǯ/ǮΨ) ׻
    do k = RegZmin + 1, IntHeightUp 
       do i = RegXmin + 1, RegXMax
          HeatSum = HeatSum + DelZ * CpDry * xz_DensSum(i,k)
       end do
    end do

    ! Ǥ (/Ψ) ׻
    do k = IntHeightUp + 1, IntHeightUp2 
       do i = RegXmin + 1, RegXMax
          CoolSum = CoolSum + DelZ * CpDry * xz_DensSum(i,k)
       end do
    end do

    ! ǮΨλ
    ! RadCoolRate ͤǤ뤳Ȥ. 
    RadHeatRate = - RadCoolRate * CoolSum / HeatSum

    xz_RadHeatBalance = &
      & xz_RadHeight * RadHeatRate  &
      & / ( xz_ExnerBasicZ  * DayTime ) &
      & + xz_RadHeight2 * RadCoolRate  &
      & / ( xz_ExnerBasicZ  * DayTime )

!    WorkRad = HeatSum * RadHeatRate + CoolSum * RadCoolRate
!    WorkRad = DelZ * CpDry * xz_ExnerBasicZ * xz_RadHeatBalance * xz_DensSum
!    WorkRad2 = sum( WorkRad(RegXMin+1:RegXMax, RegZMin+1:RegZMax) )

    call StorePotTempRad( xz_RadHeatBalance )

!    write(*,*) "net radiative heating", WorkRad2
    
  end function xz_RadHeatBalance
  
  
  
!!!------------------------------------------------------------------------!!!
  function xz_NewtonCool(xz_PotTemp)
    !
    ! ̤Ͷ. 
    ! ɽ̤ RadHeight ǻꤵ줿٤ޤǤδ֤ǰѤͿ. 
    ! 
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !̤ξ
    real(8)               :: xz_NewtonCool(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !Ͷ
    real(8)               :: xz_PotTempMean(DimXMin:DimXMax, DimZMin:DimZMax)
                                       !̾ʿ
    real(8)               :: EFTime    !ʹ»
    integer               :: k

    !ʹ»֤ 5 
    EFTime = 5.0d0 * DayTime  
    
    do k = DimZMin, DimZMax
      xz_PotTempMean(:,k) = sum( xz_PotTemp(:,k) ) / real(DimXMax - DimXMin + 1)
    end do
    
    xz_NewtonCool = - xz_PotTempMean / EFTime 
    
    call StorePotTempDamp( xz_NewtonCool )

  end function xz_NewtonCool
  
end module Radiation
