!= Module BasicEnvInit
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: bascset.f90,v 1.1 2011-03-30 13:53:06 sugiyama Exp $
! Tag Name::  $Name: arare4-20110603 $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
module Bscset
  !
  !ǥեȤδܾꤹ뤿Υ֥롼. 
  !ܾ׻, BasicSet ⥸塼ͤ. 
  !
  !ѥν꤫, ܾ(hogeBasicZ ѿ)
  !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
  !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
  !֥롼Ѥ뤿Ǥ. 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify
  use gtool_history   
  use gridset,  only: DimXMin,       &! X β
    &                 DimXMax,       &! X ξ
    &                 DimZMin,       &! Z β
    &                 DimZMax,       &! Z ξ
    &                 RegZMin,       &! Z β
    &                 RegZMax,       &! Z ξ
    &                 SpcNum,        &!Žʬο
    &                 z_Z,           &!顼ʻǤι
    &                 DelZ            !Z γʻֳ
  use basicset, only: BasicSetArray_Init, &!
    &                 PressBasis,    &!̤δవ
    &                 GasRDry,       &!ʬ갵Ǯ
    &                 CpDry,         &!ʬ갵Ǯ
    &                 CvDry,         &!ʬǮ
    &                 MolWtDry,      &!ʬʬ
    &                 SpcWetMolFr,   &!Žʬν
    &                 MolWtWet,      &!Žʬʬ
    &                 Grav,          &!ϲ®
    &                 Tropopause,    &!ή̹
    &                 TempSfc,       &!ɽ̲
    &                 PressSfc,      &!ɽ̰
    &                 GasRUniv        !
  use Boundary,only:  BoundaryXCyc_xz,  &!
    &                 BoundaryZSym_xz,  &!  
    &                 BoundaryXCyc_xza, &!
    &                 BoundaryZSym_xza   !  
  use ECCM,     only: ECCM_Dry,              &!
    &                 ECCM_Wet              
  use chemcalc, only: SvapPress,        &!
    &                 LatentHeatPerMol, &!
    &                 ReactHeatNH4SHPerMol
    
  !ۤηػ
  implicit none

  !ǥեȤ private
  private

  real(8), save  :: DryHeight = 0.0d0

  !
  public bscset_init

contains


  subroutine ECCM_init(cfgfile)
    !
    ! ECCM ⥸塼ν롼
    !

    !ۤηػ
    implicit none

    !
    !NAMELIST Ͷ
    !

    character(*), intent(in) :: cfgfile
    
    ! NAMELIST 
    NAMELIST /eccm/ DryHeight
    
    open (10, FILE=cfgfile)
    read(10, NML=eccm)
    close(10)
    
    !ǧ
    call MessageNotify( "M", "ECCM_init", "DryHeight = %f", d=(/DryHeight/) )
    
  end subroutine ECCM_init


  subroutine bscset_init(cfgfile)

    !ۤηػ
    implicit none
    
    !ѿ
    character(*), intent(in) :: cfgfile
    real(8)                  :: xz_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xz_PressBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xz_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xz_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xz_PotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xz_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: xza_MixRtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
    real(8)                  :: xz_EffMolWtBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)                  :: z_TempBasicZ(DimZMin:DimZMax)
    real(8)                  :: z_PressBasicZ(DimZMin:DimZMax)
    real(8)                  :: MolFrIni(SpcNum)
    real(8)                  :: xza_MolFr(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
    real(8)                  :: za_MolFr(DimZMin:DimZMax, SpcNum)
    real(8)                  :: xza_MixRtDivMolWt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
    real(8)                  :: Humidity = 0.0d0          !м 
    character(20)            :: Type = ""                 !ܾβ, 'Dry' or 'Moist'   
    real(8)                  :: TempStrat = 200.0d0       !طβ [k]
    real(8)                  :: Dhight = 5.0d3            !ŤߴؿΥѥ᡼ [m]  
    real(8)                  :: z_llhum(DimZMin:DimZMax)
    integer                  :: i, s
     
    !---------------------------------------------------------------
    ! NAMELIST 
    !---------------------------------------------------------------
    NAMELIST /basicenv/ Type, Humidity, TempStrat, Dhight
    
    !---------------------------------------------------------------
    ! ν
    !---------------------------------------------------------------
    xz_PressBasicZ    = 0.0d0
    xz_ExnerBasicZ    = 0.0d0
    xz_TempBasicZ     = 0.0d0
    xz_PotTempBasicZ  = 0.0d0
    xz_VelSoundBasicZ = 0.0d0
    xza_MixRtBasicZ   = 0.0d0
    xz_EffMolWtBasicZ = 0.0d0
    z_TempBasicZ      = 0.0d0
    z_PressBasicZ     = 0.0d0
    za_MolFr          = 0.0d0
    
    !---------------------------------------------------------------
    ! Type 򸵤, , , 
    !---------------------------------------------------------------
    MolFrIni = SpcWetMolFr(1:SpcNum) 
    open (10, FILE=cfgfile)
    read(10, NML=basicenv)
    close(10)
    
    select case(Type)
    case("Dry") ! ǮŪʽ
      call ECCM_Dry( MolFrIni, Humidity, z_TempBasicZ, z_PressBasicZ, za_MolFr )
      call bscset_upper(Humidity, TempStrat, Dhight, z_TempBasicZ, z_PressBasicZ)
      
    case("Wet") ! ǮŪʽ
      call ECCM_Wet( MolFrIni, Humidity, z_TempBasicZ, z_PressBasicZ, za_MolFr )
      call bscset_upper(Humidity, TempStrat, Dhight, z_TempBasicZ, z_PressBasicZ) 
      
    case("Yamasaki1983") ! Yamasaki(1983)β٤м٤δ¬ͤѤ 
      call ECCM_Ymazaki1983( z_TempBasicZ, z_PressBasicZ, za_MolFr )
      
    case("Takemi2007") ! Takemi(2007)δܾѤ
      call ECCM_Takemi2007( z_TempBasicZ, z_PressBasicZ, za_MolFr, z_llhum )
    end select
    
    ! 2 ˳Ǽ
    do i = DimXMin, DimXMax
      xz_TempBasicZ(i,:)  = z_TempBasicZ  
      xz_PressBasicZ(i,:) = z_PressBasicZ  
    end do
    
    !
    call BoundaryXCyc_xz( xz_TempBasicZ )
    call BoundaryZSym_xz( xz_TempBasicZ )
    call BoundaryXCyc_xz( xz_PressBasicZ )
    call BoundaryZSym_xz( xz_PressBasicZ )
    
    !---------------------------------------------------------------
    ! 
    !---------------------------------------------------------------
    !ʿˤϰ
    do i = DimXMin, DimXMax      
      xza_MolFr(i,:,:) = za_MolFr
    end do
    
    !Υ򺮹Ѵ
    do s = 1, SpcNum
      xza_MixRtBasicZ(:,:,s) = xza_MolFr(:,:,s) * MolWtWet(s) / MolWtDry
    end do
    
    !
    call BoundaryXCyc_xza( xza_MixRtBasicZ )
    call BoundaryZSym_xza( xza_MixRtBasicZ )
    
    !---------------------------------------------------------------
    ! ʬ̤θ
    !---------------------------------------------------------------
    do s = 1, SpcNum
      xza_MixRtDivMolWt(:,:,s) = xza_MixRtBasicZ(:,:,s) / MolWtWet(s)
    end do
    
    xz_EffMolWtBasicZ = &
      & (1.0d0 + sum(xza_MixRtBasicZ,3) ) &
      & / ( MolWtDry * ((1.0d0 / MolWtDry) + sum(xza_MixRtDivMolWt,3)) )
    
    !  
    call BoundaryXCyc_xz( xz_EffMolWtBasicZ )
    call BoundaryZSym_xz( xz_EffMolWtBasicZ )  
    
    !---------------------------------------------------------------    
    ! 
    !---------------------------------------------------------------
    xz_PotTempBasicZ = &
      & xz_TempBasicZ * (PressBasis / xz_PressBasicZ) ** (GasRDry / CpDry) 
    
    !  
    call BoundaryXCyc_xz( xz_PotTempBasicZ )
    call BoundaryZSym_xz( xz_PotTempBasicZ )
    
    !---------------------------------------------------------------    
    ! ʡؿ
    !---------------------------------------------------------------
    xz_ExnerBasicZ = xz_TempBasicZ / xz_PotTempBasicZ    
    
    !
    call BoundaryXCyc_xz( xz_ExnerBasicZ )
    call BoundaryZSym_xz( xz_ExnerBasicZ )
    
    !---------------------------------------------------------------    
    ! ̩
    !---------------------------------------------------------------
    xz_DensBasicZ = &
      & PressBasis * (xz_ExnerBasicZ ** (CvDry / GasRDry)) &
      &  / (GasRDry * xz_PotTempBasicZ / xz_EffMolWtBasicZ)
    
    !
    call BoundaryXCyc_xz( xz_DensBasicZ )
    call BoundaryZSym_xz( xz_DensBasicZ )
    
    !---------------------------------------------------------------    
    ! ®
    !---------------------------------------------------------------
    xz_VelSoundBasicZ = &
      & sqrt ( &
      &   CpDry * GasRDry * xz_ExnerBasicZ * xz_PotTempBasicZ &
      &   / (CvDry * xz_EffMolWtBasicZ) &
      & )
    
    !
    call BoundaryXCyc_xz( xz_VelSoundBasicZ )
    call BoundaryZSym_xz( xz_VelSoundBasicZ )
    
    !----------------------------------------------------------
    ! BasicSet ⥸塼ͤ
    !----------------------------------------------------------
    call BasicSetArray_Init(                                  &
      & xz_PressBasicZ,    xz_ExnerBasicZ, xz_TempBasicZ,     &
      & xz_PotTempBasicZ,  xz_DensBasicZ,  xz_VelSoundBasicZ, &
      & xza_MixRtBasicZ, xz_EffMolWtBasicZ )

  end subroutine bscset_init


  subroutine bscset_upper(Humidity, TempStrat, Dhight, z_TempBasicZ, z_PressBasicZ)
    !
    !
    !ǥեȤδܾꤹ뤿Υ֥롼. 
    !ܾ׻, BasicSet ⥸塼ͤ. 
    !
    !ѥν꤫, ܾ(hogeBasicZ ѿ)
    !׻ʬBasicSet ⥸塼뤫ڤΥƤ. 
    !ECCM Ϥ, BasicSet Τ˰¸뤬 hogeBasicZ  use ʤ
    !֥롼Ѥ뤿Ǥ. 
    !
    
    implicit none
    
    integer :: k
    real(8), intent(in)    :: Humidity      !ܾм
    real(8), intent(in)    :: TempStrat     !طβ [k]
    real(8), intent(in)    :: Dhight        !ŤߴؿΥѥ᡼ [m]
    real(8), intent(inout) :: z_TempBasicZ(DimZMin:DimZMax)
    real(8), intent(inout) :: z_PressBasicZ(DimZMin:DimZMax)
    real(8) :: z_DTempDZ(DimZMin:DimZMax)
    real(8) :: DTempDZ
    real(8) :: Weight
    
    
    do k = RegZMin+1, DimZMax-1     
      z_DTempDZ(k) = (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / DelZ
    end do
    
    ! ή̤ΰ
    !   ̤絤Ȥ. 絤絤ؤܤ 
    !   tanh ѤƤʤ餫ˤĤʤ
    do k = RegZMin+1, DimZMax
      
      !ŤߤĤδؿѰ. tanh Ѥ
      Weight = ( tanh( (z_Z(k) - tropopause ) / Dhight ) + 1.0d0 ) * 5.0d-1
      
      !ͤȤƲ٤׻. ̤Ǥ TempStrat 絤˶Ť
      z_TempBasicZ(k) = z_TempBasicZ(k) * ( 1.0d0 - Weight ) + TempStrat * Weight
      
      !ٸΨǮٸΨ꾮ʤʤ褦
      DTempDZ = &
        & max( z_DTempDZ(k), (z_TempBasicZ(k) - z_TempBasicZ(k-1)) / DelZ )
      
      !ܾβ٤
      z_TempBasicZ(k) = z_TempBasicZ(k-1) + DTempDZ * DelZ 
      
      !Ϥſ尵ʿդ׻
      z_PressBasicZ(k) =                                                    &
        &  z_PressBasicZ(k-1) * ( ( z_TempBasicZ(k-1) / z_TempBasicZ(k) )   &
        &    ** (Grav * MolWtDry / ( DTempDZ * GasRUniv ) ) )
    end do
    
  end subroutine Bscset_upper

!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Yamasaki1983( z_Temp, z_Press, za_MolFr )
    !
    !== 
    !  * Yamasaki, 1983 β٤м٤δ¬ͤǴܾ
    !    * ٤δܾ
    !      * ¬ǡNetCDFե벽Τͤɤ߹
    !        * ɤ߹֤ͤƲ٤δܾ
    !    * ٤δܾ
    !      * м٤ subroutine HUM ǺѤ
    !        * Ǥм٤ѴƼ٤δܾ 
    !    * δܾ
    !      * ʬȴʬʬ̺θſ尵ʿդ׻
    !

    implicit none

    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) !
    real(8)             :: Ob_altitude(1:89)       !¬ǡб
    real(8)             :: Ob_HumZ(1:88)           !м٤δ¬(1)
    real(8)             :: z_HumZ(DimZMin:DimZMax) !м٤δܾ(%)
    real(8)        :: Observed_Temp(1:100,1:89)!NetCDF ɤ߹δ¬(2)
    real(8)        :: Ob_TempZ(1:89)           !NetCDF ɤ߹δ¬(1)
    real(8)             :: z_PressSaturated(DimZMin:DimZMax)!Tetens(1930) ˰¾
    integer             :: k, s, i, m, b

    z_HumZ = 0.0d0

    ! subroutine HUMм٤δܾ
    call HUM(z_HumZ, Ob_altitude, Ob_HumZ)

    ! ٥ǡNetCDF֤

    ! NetCDF ե뤫εδ¬ͤɤ߹
    call HistoryGet('Ob_Temp.nc', 'Ob_Temp', array=Observed_Temp)
    
    ! ٤δ¬ͤΥե"Ob_Temp.nc"2ǡ(x,z)ʤΤ
    ! 1ǡ(z)ˤ
    do m=1,89
      Ob_TempZ(m) = Observed_Temp(1,m)
    end do

    ! Ob_TempZ ֤Ʋ٤δܾ z_Temp 
    ! kansoku_altitude(m) < z_Z(k) < kansoku_altitude(m+1),
    ! kansoku_altitude = z_Z(k),
    ! kansoku_altitude < z_Z(k)
    ! 3ĤǾʬ

    ! 
    z_Temp = 1.0d-60      

    do k = RegZMin+1,DimZMax
     do m = 1,88

      ! z_Z  Ob_altitude Τ֤˶ޤȤ,
      ! ζ֤ Obaltitude(m), Obaltitude(m+1) 
      ! ľ Ob_TempZ ֤
      if (Ob_altitude(m).ne.z_Z(k).and.z_Z(k).gt.Ob_altitude(m) &
          & .and.z_Z(k).lt.Ob_altitude(m+1)) then
        z_Temp(k) = Ob_TempZ(m)+((Ob_TempZ(m+1)-Ob_TempZ(m)) &
        & /(Ob_altitude(m+1)-Ob_altitude(m)))*(z_Z(k)-Ob_altitude(m))

      ! z_Z(k) = Obaltitude(m) λ, Ob_TempZ(m) = z_Temp(k) Ǥ
      else if (Ob_altitude(m).eq.z_Z(k)) then
        z_Temp(k) = Ob_TempZ(m)

      ! z_Z(k) > Ob_altitude Ǥϴ¬ǡ̵Τ絤ˤ
      else if (Ob_altitude(m).lt.z_Z(k)) then
        z_Temp(k) = z_Temp(k-1)

      end if
     end do
    end do

    ! ȥ׻

    ! 
    z_Press = 1.0d-60

    ! ɽ̵Ȳ٤絤ǲؤε
    ! ſ尵μ dP/dz = - \rho * g 
    ! ñΤ, \rho = 1 kg/m^3 δ絤ꤷƤ
    z_Press(RegZMin+1) = PressSfc - (Grav * DelZ)

    ! 絤ǲؤΥ׻
    za_MolFr(RegZMin+1,1) = SvapPress( 6,z_Temp(RegZMin+1)) * &
                           &(z_HumZ(RegZMin+1)/100)/z_Press(RegZMin+1)

    ! Tetens(1930) ˰¾ȤäƤߤΤǰʲǷ׻
    do k=RegZMin+1,DimZMax
      z_PressSaturated(k) = 6.11*(10**(7.5*(z_Temp(k)-273)/(z_Temp(k)-35.7)))*100
    end do

    ! 絤ǲؤͤ򸵤, ȼ٤δܾ
    ! ϼʬȴʬʬ̺θſ尵ʿդ׻
    ! м٤ϥѴ
    ! ʲifʸDryHeightϴܾ˴礷ؤɬפ
    ! NAMELISTǱľΰʾͤꤷƤд礷ؤʤ

    ! ٤δܾη׻
    do k = RegZMin+1,DimZMax-1
     if (z_Z(k+1).lt.DryHeight) then
        za_MolFr(k+1,1) = SvapPress( 6,z_Temp(k)) * (z_HumZ(k)/100)/z_Press(k)

    ! δܾη׻
      z_Press(k+1) = &
         & z_Press(k)-(Grav*z_Press(k)*DelZ) &
         & /((GasRUniv/ &
         & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
         & *z_Temp(k))

      !DryHeightΰ褬ȤϾǵ᤿򥼥ˤ
      !絤ˤſ尵μ鵤
      else if (z_Z(k+1).ge.DryHeight) then
        za_MolFr(k+1,1) = 0.0d0

        z_Press(k+1) = &
           & z_Press(k)-(Grav*z_Press(k)*DelZ) &
           & /((GasRUniv/MolWtDry)*z_Temp(k))
      end if
    end do


  end subroutine ECCM_YAMASAKI1983

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"BASE CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !
    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)

      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do

    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      else if (k.le.TR.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      else if (k.gt.TR) then
        z_RH(k) = 0.25
      end if
    end do
  end subroutine HUM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_TDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * پȤϴΤ㤦
    !

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)

      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do

    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmʲμ٤ϥˤƤ
    ! , 絤Υȥ쥤ȤθǮӤ"DRY CASE"Ǥ
    !  2.5 km, 5.0 km, 7.5 km Τɤм٤ 20 % 餹DRY1,2,3Ѱդ
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km  (2.5 km, 5.0 km, 7.5 km) ޤǤϤΤޤѲ

!     else if (z_Z(k).lt.2500.and.k.gt.LL) then   ! DRY1
!     else if (z_Z(k).lt.5000.and.k.gt.LL) then   ! DRY2
      else if (z_Z(k).lt.7500.and.k.gt.LL) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      ! (2.5 km, 5.0 km, 7.5 km)20 % ٤򸺾 
!     else if (z_Z(k).ge.2500) then   ! DRY1
!     else if (z_Z(k).ge.5000) then   ! DRY2
      else if (z_Z(k).ge.7500) then   ! DRY3
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.20d0

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_TDRY

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007_MDRY(z_RH,Ztr,TR,LL)
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * Takemi(2007) ǮӾپм٤"DRY CASE"
    !      1.5km ʾμ٤׻Ƥ(ܺ٤Takemi(2007)ο2򻲾ȤΤ)
    !     * Takemi(2007)ǤϹ1.5kmʾϤؿͿƤ뤬,
    !       1.5kmʲϰκͿƤ뤿,
    !       1.5kmʲμ٤ϲ٤䵤ޤʤʤΤǸǵ
    !     * ǮӾȤϴΤ㤦

    implicit none

    real(8),intent(out) :: z_RH(DimZMin:DimZMax) !Relative Humidity(м)
    real(8),intent(out) :: Ztr                   !ή̤ι
    integer,intent(out) :: TR                    !ή̤ι٤γʻֹ
    integer,intent(out) :: LL                    ! 1.5 km ľγʻֹ (Low Level)
    integer :: k

    z_RH = 0.0d0
    Ztr  = 0.0d0

    ! Ztrή̹٤ͤͿ
    ! Takemi(2007)Ǥ12km, ɬʻ礦12kmˤϾʤ,
    ! 12km,12kmľΰ֤ή̤ˤ
    do k = RegZMin+1,DimZMax

      ! z_Z  礦 12 km ʤ 12 km ή
      if (z_Z(k).eq.12000) then
        Ztr = z_Z(k)

      ! z_Z 礦12kmǤϤʤä,12kmľz_ZήZtrˤʤ
      else if (z_Z(k).gt.12000) then
        Ztr = minval( z_Z, 1, z_Z > 12000 )
      end if
    end do

    ! ή̹٤γʻ (Ztr = z_Z(TR))
    do k = RegZMin+1,DimZMax
      if (z_Z(k).ge.12000.and.z_Z(k).le.(12000 + DelZ)) then
        TR = k
      end if
    end do

    ! 1.5km⤷Ϥľγʻֹ
    do k = RegZMin+1,DimZMax
      if (z_Z(k).le.1500.and.z_Z(k).ge.(1500 - DelZ)) then
        LL = k
      end if
    end do


    ! Takemi(2007)μѤм٤
    ! Ȥꤢ1.5kmޤǤμ٤ϥˤƤ
    ! 絤Υȥ쥤Ȥθپ"DRY CASE"Ǥ
    !  2.5 km м٤ 13 % ⤷ 30 % 餹 DRY1,2 Ѱդ.
    do k = RegZMin+1, DimZMax
      if (k.le.LL) then
        z_RH(k) = 0.0d0

      ! 1.5 km 2.5 km ޤǤϤΤޤѲ
      else if (z_Z(k).lt.2500.and.k.gt.LL) then
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25

      ! 2.5 km ʹߤ 13 % or 30 % 餹
      else if (z_Z(k).ge.2500) then
!       z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.13d0   ! DRY1
        z_RH(k) = 1.0d0 - 0.750d0 * (z_Z(k) / Ztr)**1.25 - 0.30d0   ! DRY2

      end if
    end do

    ! м٤ 25% ʲˤʤ 25% Ǹꤹ
    do k = RegZMin+1, DimZMax
      if (z_RH(k).le.(0.25).and.k.gt.LL) then
        z_RH(k) = 0.250d0
      end if
    end do

  end subroutine HUM_Takemi2007_MDRY

!!!------------------------------------------------------------------------------!!!
  subroutine ECCM_Takemi2007( z_Temp, z_Press, za_MolFr, z_LLhumidity )
    !
    !== 
    ! * deepconv ϵѤΥƥȷ׻ȤTakemi(2007)κƸ׻
    !   뤿μ٤δܾ
    !   * ܾβ٤μ̤ͿƤ뤿, ٤Ѵɬפ
    !

    implicit none

    real(8), intent(out):: z_Press(DimZMin:DimZMax)!
    real(8), intent(out):: z_Temp(DimZMin:DimZMax) !
    real(8), intent(out):: za_MolFr(DimZMin:DimZMax, 1:SpcNum) !
    real(8), intent(out) :: z_LLhumidity(DimZMin:DimZMax)  ! 1.5 km ޤǤм
    !
    ! ECCM_TakemiǤΤɬפѿ
    !
    real(8) :: z_TakemiRH(DimZMin:DimZMax)         ! 1.5km ʾм
    real(8) :: z_TakemiTheta(DimZMin:DimZMax)      !ܾβ
    real(8) :: Theta_0                             ! ɽ̤β
    real(8) :: Theta_tr                            ! ή̤β
    real(8) :: TakemiZtr                           ! ή̤ι
    real(8) :: HumSfc                              ! ɽ̤м
    real(8) :: a_MolFrSfc                          ! ɽ̤Υ
!!--------------------------------------------------
    integer             :: k, s, i, m, b, T, L

    z_TakemiRH = 0.0d0
    z_TakemiTheta = 0.0d0

    ! پ
    call HUM_Takemi2007(z_TakemiRH,TakemiZtr,T,L)
!   call HUM_Takemi2007_TDRY(z_TakemiRH,TakemiZtr,T,L)
!   call HUM_Takemi2007_MDRY(z_TakemiRH,TakemiZtr,T,L)

    ! ١١

    !ɽ̤β̤300K
    Theta_0 = 300.0d0

    ! پǮӾ
    ! ή̤β̤Ƕ̤Ƥ
!   Theta_tr = 343.0d0     ! 
    Theta_tr = 358.0d0     ! Ǯ

    ! 絤ǲؤβ
    z_TakemiTheta(RegZMin+1) = Theta_0 + &
                           & (Theta_tr - Theta_0)*(z_Z(RegZMin+1) / TakemiZtr)**1.25

    z_Temp  = 1.0d-60
    z_Press = 1.0d-60
    z_LLhumidity = 0.0d0

    ! 絤ǲؤε桦ʬ̤η׻

    ! ɽ̤Υ
    ! 10g/kg18g/kgκͿƤ뤿ľ
    ! ʤǮӾQ18Τ߻
    a_MolFrSfc = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   a_MolFrSfc = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   a_MolFrSfc = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   a_MolFrSfc = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   a_MolFrSfc = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10 

    ! ɽ̤м
    ! 椫ջ. Τɬ
    HumSfc = a_MolFrSfc * PressSfc / SvapPress(6,TempSfc)

    ! 絤ǲؤε
    z_Press(RegZMin+1) = &
           & PressSfc - (Grav * PressSfc * DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + a_MolFrSfc * (MolWtWet(1) - MolWtDry))) &
           & *TempSfc)

    ! 絤ǲؤβ.̤򸵤˷׻
    ! ɽ̵ 1000hPa Ȳꤹ
    z_Temp(RegZMin+1) = z_TakemiTheta(RegZMin+1) &
                        &* (z_Press(RegZMin+1) / 100000.0d0)**(GasRDry / CpDry)

    ! 絤ǲؤΥ
    ! ǮӾQ18Τ߻
    za_MolFr(RegZMin+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)  ! Q18
!   za_MolFr(RegZMin+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)  ! Q16
!   za_MolFr(RegZMin+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)  ! Q14
!   za_MolFr(RegZMin+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)  ! Q12
!   za_MolFr(RegZMin+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)  ! Q10
 
    ! 絤ǲؤм
    ! 椫ջ. Τɬ
    z_LLhumidity(RegZMin+1) = za_MolFr(RegZMin+1,1) &
                              &* z_Press(RegZMin+1) / SvapPress(6,z_Temp(RegZMin+1))

    ! 絤ǲؤμʪ̤Ȥ˲١ٵδܾ
    !  0 - 1.5km  1.5km - Ǽ٤Ϳۤʤ,
    ! , ή̰ʾǤϲ٤μۤʤΤ, ʲ 3ѥʬ
    ! ܾ
    !  0 - 1.5km, 1.5km - ή(Ztr), Ztrʾ 
    do k = RegZMin+1, DimZMax

    !
    ! ܾ(I)
    ! 絤ǲؤ 1.5 km ʲ(k  L-1 ʲ)δܾ
    !
     if (k.le.L-1) then

      ! 
      !  1.5km ޤǤϥ椬ǤդͤǸꤵƤ
      ! , ǮӾ 18 g/kg Τ
      za_MolFr(k+1,1) = 0.0180d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0160d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0140d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0120d0 * MolWtDry / MolWtWet(1)
!     za_MolFr(k+1,1) = 0.0100d0 * MolWtDry / MolWtWet(1)
 
      ! 
      z_Press(k+1) = &
           & z_Press(k)-(Grav*z_Press(k)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k))

      ! ̤鲹٤׻
      z_TakemiTheta(k+1) = Theta_0 + (Theta_tr - Theta_0)*(z_Z(k+1) / TakemiZtr)**1.25
      z_Temp(k+1) = z_TakemiTheta(k+1) * (z_Press(k+1) / 100000.0d0)**(GasRDry / CpDry)

      ! 椫м٤׻
      z_LLhumidity(k+1) = za_MolFr(k+1,1) * z_Press(k+1) / SvapPress(6,z_Temp(k+1))

      !
      !== Takemi(2007)δܾλѾ
      !  * ؤǺꤷ³ȹ 1.5km ޤǤм٤100%Ķ٤
      !  * 100% ĶƤޤä٤μ٤, ľι٤μ٤ˤ
      !    Takemi(2007)Ʊ٤αľץե뤬
      !    * ʤ
      !  * MQ16   99.% ȤͤФ, 100% ĶʤƤۤ100%
      !    ͤФƤޤ
      !    * Takemi(2007)ǤϤΤ褦ͤ褦ˤϸʤ
      !      礦ʤΤMQ18 MQ14  100% Ķľͤδ֤äͤƤ
      !      * 0.94511507230d0Ȥ嵭
      if (z_LLhumidity(k+1).gt.1) then
        z_LLhumidity(k+1) = z_LLhumidity(k)
!     if (z_LLhumidity(k+1).gt.0.99) then      !MQ16 
!       z_LLhumidity(k+1) = 0.94511507230d0    !MQ16 
     end if

     !
     ! ܾ(II)
     !  1.5km , ή̰ʲ(L < k < T)δܾ
     !
     else if (k.le.T.and.k.gt.L) then

      ! k = L Ǥм
      !  if ʸν k  L+1 Ϥޤ z_TakemiRH(L) ֳʤΤͤͿ
      z_TakemiRH(L) = z_LLhumidity(L)

      ! δܾ
      z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k+1,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_0 + (Theta_tr - Theta_0)*(z_Z(k) / TakemiZtr)**1.25
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)
     
       !
       ! ܾ(III)
       ! ή̤ (k > T) ξ
       !
       else if (k.gt.T) then

       ! δܾ
       z_Press(k) = &
           & z_Press(k-1)-(Grav*z_Press(k-1)*DelZ) &
           & /((GasRUniv/ &
           & (MolWtDry + za_MolFr(k,1) * (MolWtWet(1) - MolWtDry))) &
           & *z_Temp(k-1))

       ! ̤鲹٤׻
       z_TakemiTheta(k) = Theta_tr * exp(Grav * (z_Z(k) - TakemiZtr) / (CpDry * z_Temp(T)))
       z_Temp(k) = z_TakemiTheta(k) * (z_Press(k) / 100000.0d0)**(GasRDry / CpDry)

       ! 絤ʿʬ
       za_MolFr(k,1) = SvapPress( 6,z_Temp(k))* z_TakemiRH(k)/z_Press(k)

     end if
    end do

 end subroutine ECCM_Takemi2007

!!!------------------------------------------------------------------------------!!!
  subroutine HUM_Takemi2007ALL(z_RHall)
    !
    !== 
    ! Takemi(2007) ǤμپͿԹ, 1.5kmʲȹ1.5kmʾ
    ! м٤̡˵᤿
    ! Ԥ HUM_Takemi2007 or HUM_Takemi2007_TDRY or HUM_Takemi2007_MDRY ǵ
    ! Ԥ ECCM_Takemi2007 ǵƤ.
    ! Τ, ٤Ǥм z_RHall ǧΤˤ뤿,
    ! Υ֥롼ξԤ礷Ƥ
    ! ͤγǧŪʤ, Ūɬפʤ, ECCM_MolFrɬפʤȤ
    ! м٤ɬפʤȤ⤢, Ƥ

    implicit none

    real(8),intent(out) :: z_RHall(DimZMin:DimZMax)
    real(8) :: a_MolFrIn(1:SpcNum)
    real(8) :: Humidit
    real(8) :: z_Tem(DimZMin:DimZMax)
    real(8) :: z_Pre(DimZMin:DimZMax)
    real(8) :: z_MolMea(DimZMin:DimZMax)
    real(8) :: za_MolF(DimZMin:DimZMax)
    real(8) :: ZTR
    real(8) :: z_humidity1(DimZMin:DimZMax) !0 - 1.5 km м
    real(8) :: z_humidity2(DimZMin:DimZMax) !1.5 km ʾм
    integer :: k, T, L

    !1.5kmʲμ٤
    call ECCM_Takemi2007(z_Tem, z_Pre, za_MolF, z_humidity1)

    !1.5kmʾμ٤
    !Ĥ
    call HUM_Takemi2007(z_humidity2, ZTR, T, L)
!   call HUM_Takemi2007_TDRY(z_humidity2, ZTR, T, L)
!   call HUM_Takemi2007_MDRY(z_humidity2, ZTR, T, L)

    do k = RegZMin+1, DimZMax
      if (k.le.L) then
        z_RHall(k) = z_humidity1(k)

      else if (k.gt.L) then
        z_RHall(k) = z_humidity2(k)

      end if
    end do

  end subroutine HUM_Takemi2007ALL

!!------------------------------------------------------------------------------!!!
  subroutine HUM(z_humid, kansoku_altitude, kansoku_HumZ)
    !
    !== 
    !
    !  * Yamasaki, 1983 μ٤δ¬ǡܾ 
    !    * м٤δ¬ǡNetCDFե벽Τͤɤ߹
    !    * ɤ߹֤ͤм٤δܾ
    !

    implicit none

    real(8) :: Observed_Humidity(1:100,1:88)        !NetCDF ɤ߹м٤δ¬
                                                    !ʿͤ2ǡ
    real(8),intent(out) :: kansoku_HumZ(1:88)       !ľ1ˤм٤δ¬ͤ
    real(8),intent(out) :: z_humid(DimZMin:DimZMax) !֤м
    real(8),intent(out) :: kansoku_altitude(1:89)   !¬ǡб
    integer :: k,m

    z_humid = 0.0d0
    kansoku_altitude = 0.0d0
    kansoku_HumZ = 0.0d0

    ! ¬ǡб٤Ϳ
    ! ֤κݤ˻Ѥ
    ! ʤ, Yamsaki(1983)ˤ븵ǡϥǡֳ֤ФФǤäΤ
    ! 250mֳ֤ľΤѤƤ
    do m = 1,89
     kansoku_altitude(m) = 25.0d1*(m-1)
    end do

    ! NetCDF ե뤫м٤ɤ߹
    call HistoryGet('Ob_Humidity.nc', 'Ob_Humidity', array=Observed_Humidity)

    ! м٤δ¬ͤΥե"Ob_Humidity.nc"2ǡ(x,z)Ǥ뤿
    ! 1ǡˤ
    do m=1,88
      kansoku_HumZ(m)  = Observed_Humidity(1,m)
    end do
    
    ! kansoku_HumZ ֤z_humid
    ! kansoku_altitude(m) < z_Z(k) < kansoku_altitude(m+1),
    ! kansoku_altitude = z_Z(k),
    ! kansoku_altitude < z_Z(k)
    ! 3ĤǾʬ
    do k = RegZMin+1,DimZMax
     do m = 1,87
      if (kansoku_altitude(m).ne.z_Z(k).and.z_Z(k).gt.kansoku_altitude(m) &
         & .and.z_Z(k).lt.kansoku_altitude(m+1)) then
        z_humid(k) = kansoku_HumZ(m)+((kansoku_HumZ(m+1) - kansoku_HumZ(m)) &
        & /(kansoku_altitude(m+1)-kansoku_altitude(m)))*(z_Z(k)-kansoku_altitude(m))

      else if (kansoku_altitude(m).eq.z_Z(k)) then
        z_humid(k) = kansoku_HumZ(m)

      else if (kansoku_altitude(m).lt.z_Z(k)) then
        z_humid(k) = z_humid(k-1)
      end if
     end do
    end do

  end subroutine HUM


  subroutine Yamazaki1983
    real(8) :: Temp(1:89) ! ٤δ¬ǡ
    real(8) :: Hum(1:89)  ! м٤δ¬ǡ
    
    Temp = (/ &
      & 300.00, 298.00, 296.00, 294.22, 293.15, 291.08, 289.80, 288.55, 287.30, 286.50, &
      & 284.78, 283.49, 282.16, 280.81, 279.45, 278.07, 276.70, 275.33, 273.95, 272.58, &
      & 271.20, 269.83, 268.45, 267.06, 265.63, 264.19, 262.70, 261.20, 259.68, 258.11, &
      & 256.55, 254.86, 253.18, 251.41, 249.60, 247.76, 245.83, 243.89, 241.90, 240.30, &
      & 237.90, 235.90, 233.90, 231.90, 229.90, 227.90, 225.90, 223.91, 221.97, 220.03, &
      & 218.09, 216.16, 214.24, 212.42, 210.64, 208.86, 207.37, 205.96, 204.55, 203.35, &
      & 202.48, 201.60, 200.73, 200.36, 200.12, 199.89, 199.65, 199.91, 200.30, 200.70, &
      & 201.09, 201.55, 202.30, 203.05, 203.80, 204.55, 205.30, 206.05, 206.80, 207.55, &
      & 208.30, 209.05, 209.69, 210.31, 210.93, 211.54, 212.16, 212.77, 212.99 /)
    
    Hum = (/ &
      & 83.00, 88.85, 89.70, 91.70, 93.70, 94.35, 95.00, 94.35, 93.70, 91.85, 90.00, &
      & 87.50, 85.00, 82.90, 80.80, 78.80, 76.70, 74.35, 72.00, 71.00, 70.00, 68.85, &
      & 67.70, 66.85, 66.00, 65.60, 65.20, 64.75, 64.30, 63.90, 63.50, 63.10, 62.70, &
      & 62.25, 61.80, 61.40, 61.00, 61.00, 61.00, 61.35, 61.70, 61.85, 62.00, 62.15, &
      & 62.30, 62.65, 63.00, 63.00, 63.00, 63.35, 63.70, 64.50, 65.30, 66.60, 67.90, &
      & 70.10, 72.30, 73.30, 74.30, 74.60, 74.90, 68.50, 62.10, 54.05, 46.00, 41.45, &
      & 36.90, 33.25, 29.60, 24.65, 19.70, 15.75, 11.80, 9.00, 6.20, 5.25, 4.30, 3.35, &
      & 2.40, 3.35, 4.30, 2.95, 1.60, 1.05, 0.50, 0.45, 0.40, 0.35 /)


 end subroutine Yamazaki1983


end module Bscset


